/**
 * JASMINe
 * Copyright (C) 2009-2011 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:RulesManagerModelLocator.as 2485 2008-09-30 14:14:35Z nicoulaj $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.monitoring.eos.notificationeditor.cairngorm.model
{

  import com.adobe.cairngorm.model.ModelLocator;

  import org.ow2.jasmine.monitoring.eos.notificationeditor.cairngorm.business.*;
  import org.ow2.jasmine.monitoring.eos.notificationeditor.cairngorm.model.domain.*;
  import org.ow2.jasmine.monitoring.eos.notificationeditor.cairngorm.model.presentation.*;

  /**
  * Cairngorm Model Locator for the Notification Editor module
  *
  * @author Julien Nicoulaud
  */
  [Bindable]
  public class NotificationEditorModelLocator implements ModelLocator
  {
        // =====================================================================
        // Variables
        // =====================================================================

        /**
        * Singleton instance of this locator
        */
    private static var instance:NotificationEditorModelLocator;


        // Models

        /**
        * Module main domain model
        */
        public var notificationEditorModel:NotificationEditorModel;

        /**
        * Module main presentation model
        */
        public var notificationEditorPresentationModel:NotificationEditorPM;


        // Command delegates unique instances

        // None yet


        // =====================================================================
        // Construction and singleton instance access
        // =====================================================================

        /**
        * Constructor
        */
    public function NotificationEditorModelLocator()
    {
      // Instanciate the singleton
      if(instance!=null) {
        throw new Error("Error: Singletons can only be" +
                "instantiated via getInstance() method!");
      }
      NotificationEditorModelLocator.instance = this;
    }

    /**
    * AutonomousModelLocator singleton instance getter
    */
    public static function getInstance():NotificationEditorModelLocator
    {
      if(instance==null){

                // Instanciate the ModelLocator
                instance = new NotificationEditorModelLocator();

                // Instanciate the models
                instance.notificationEditorModel = new NotificationEditorModel();
                instance.notificationEditorPresentationModel = new NotificationEditorPM(instance.notificationEditorModel);

            }
      return instance;
    }


        // =====================================================================
        // Delegates getters
        // =====================================================================

        // None yet

  }
}